Option Explicit On
Option Strict On

Imports OpenCVLib
Imports System.Drawing
Imports System.Runtime.InteropServices


'//////////////////////////////////////////////////////////
''' <summary>
''' IplImage\̂̃bpNXłB
''' </summary>
''' <remarks></remarks>
Public Class IplImageWrapper

    '------------------------------------------------------
#Region "Jf[^"

    ''' <summary>C[Wf[^ւ̃A}l[W|C^ێ܂B</summary>
    Private mImagePtr As IntPtr

    ''' <summary>}l[ẄɃRs[ꂽC[Wf[^ێ܂B</summary>
    Private mIplImage As IplImage

    ''' <summary>C[Wf[^ϊς(mIplImage쐬ς)ǂێ܂B</summary>
    Private mIplImageCreated As Boolean

    ''' <summary>ϊꂽrbg}bvێ܂B</summary>
    Private mBitmap As Bitmap

    ''' <summary>\p̃EBhEێ܂B</summary>
    Private mWindow As CuWindow

    ''' <summary>}l[Ẅɓ]ꂽrbg}bvf[^łB</summary>
    Private mImage() As Byte

#End Region
#Region "Win32 API"

    ''' <summary>
    ''' RECT^\̂łB
    ''' </summary>
    ''' <remarks></remarks>
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure APIRECT
        Public Left As Integer
        Public Top As Integer
        Public Right As Integer
        Public Bottom As Integer
    End Structure

    Public Declare Function GetWindowRect Lib "user32.dll" (ByVal hWnd As IntPtr, ByRef Rect As APIRECT) As Integer
    Public Declare Function GetParent Lib "user32.dll" (ByVal hWnd As IntPtr) As IntPtr

#End Region

    '======================================================
#Region "RXgN^/fXgN^"

    ''' <summary>
    ''' C[WbpNX܂B
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()

        '
        mIplImageCreated = False
        mBitmap = Nothing
        ReDim mImage(-1)

    End Sub
    ''' <summary>
    ''' C[WbpNX܂B
    ''' </summary>
    ''' <param name="ImagePtr">bvIplImagẽ|C^</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal ImagePtr As IntPtr)
        Me.New()
        Me.Ptr = ImagePtr
    End Sub
    ''' <summary>
    ''' C[WbpNX܂B
    ''' ɂȂCX^X̃C[WƓTCY^`l̃C[W쐬܂B
    ''' </summary>
    ''' <param name="Template">ɂȂCX^X</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal Template As IplImageWrapper)
        Me.New()
        Create(Template)
    End Sub
    ''' <summary>
    ''' C[WbpNX܂B
    ''' ɂȂCX^X̃C[WƓTCYŎw肳ꂽ`l̃C[W쐬܂B
    ''' </summary>
    ''' <param name="Template">ɂȂCX^X</param>
    ''' <param name="Channels">`l</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal Template As IplImageWrapper, ByVal Channels As Integer)
        Me.New()
        Create(Template, Channels)
    End Sub
    ''' <summary>
    ''' C[WbpNX܂B
    ''' TCYƃ`lw肵ăC[W쐬܂B
    ''' </summary>
    ''' <param name="Width">TCY</param>
    ''' <param name="Height">cTCY</param>
    ''' <param name="Channels">`l</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal Width As Integer, ByVal Height As Integer, ByVal Channels As Integer)
        Me.New()
        Create(Width, Height, Channels)
    End Sub
    ''' <summary>
    ''' C[WbpNX܂B
    ''' w肳ꂽrbg}bvi[ĂC[W쐬܂B
    ''' </summary>
    ''' <param name="Bmp">ɂȂrbg}bv</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal Bmp As Bitmap)
        Me.New()
        Create(Bmp)
    End Sub
    ''' <summary>
    ''' C[WbpNX܂B
    ''' w肳ꂽC[W(rbg}bv)i[ĂC[W쐬܂B
    ''' </summary>
    ''' <param name="Img">ɂȂC[W(Bitmap)</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal Img As Image)
        Me.New()
        Dim bmp As Bitmap = TryCast(Img, Bitmap)
        If bmp Is Nothing Then
            Throw New Exception("rbg}bvȊO̓C[W𐶐ł܂B")
        End If
        Create(bmp)
    End Sub

    'fXgN^
    Protected Overrides Sub Finalize()
        If Not mBitmap Is Nothing Then
            mBitmap.Dispose()
            mBitmap = Nothing
        End If
        MyBase.Finalize()
    End Sub

#End Region

    '------------------------------------------------------
#Region "쐬"

    ''' <summary>
    ''' C[W쐬܂B
    ''' </summary>
    ''' <param name="ImgSize">TCY</param>
    ''' <param name="Channels">`l</param>
    ''' <remarks></remarks>
    Public Sub Create(ByVal ImgSize As CvSize, ByVal Channels As Integer)
        Me.Ptr = cvCreateImage(ImgSize, IPL_DEPTH_8U, Channels)
    End Sub
    ''' <summary>
    ''' C[W쐬܂B
    ''' </summary>
    ''' <param name="Width">TCY</param>
    ''' <param name="Height">cTCY</param>
    ''' <param name="Channels">`l</param>
    ''' <remarks></remarks>
    Public Sub Create(ByVal Width As Integer, ByVal Height As Integer, ByVal Channels As Integer)
        Create(New CvSize(Width, Height), Channels)
    End Sub
    ''' <summary>
    ''' C[W쐬܂B
    ''' </summary>
    ''' <param name="ImgSize">TCY</param>
    ''' <param name="Channels">`l</param>
    ''' <remarks></remarks>
    Public Sub Create(ByVal ImgSize As Size, ByVal Channels As Integer)
        Me.Ptr = cvCreateImage(New CvSize(ImgSize.Width, ImgSize.Height), IPL_DEPTH_8U, Channels)
    End Sub
    ''' <summary>
    ''' ɂȂC[WƓTCYA`l̃C[W쐬܂B
    ''' </summary>
    ''' <param name="Template">ɂȂC[W</param>
    ''' <remarks></remarks>
    Public Sub Create(ByVal Template As IplImageWrapper)
        Create(Template, Template.IplImageData.nChannels)
    End Sub
    ''' <summary>
    ''' ɂȂC[WƓTCYŎw肳ꂽ`l̃C[W쐬܂B
    ''' </summary>
    ''' <param name="Template">ɂȂC[W</param>
    ''' <param name="Channels">`l</param>
    ''' <remarks></remarks>
    Public Sub Create(ByVal Template As IplImageWrapper, ByVal Channels As Integer)
        Me.Ptr = cvCreateImage(Template.CvSize, IPL_DEPTH_8U, Channels)
        Me.Origin = Template.Origin
    End Sub
    ''' <summary>
    ''' rbg}bv̓ei[ꂽC[W쐬܂B
    ''' </summary>
    ''' <param name="Bmp">ɂȂrbg}bv</param>
    ''' <remarks></remarks>
    Public Sub Create(ByVal Bmp As Bitmap)

        'rbg}bv쐬
        Dim sz As CvSize
        sz.width = Bmp.Width
        sz.height = Bmp.Height
        Me.Ptr = cvCreateImage(sz, IPL_DEPTH_8U, 3)
        ConvertIplImage()

        'rbg}bvbN
        Dim bd As System.Drawing.Imaging.BitmapData
        Dim rct As New Rectangle(0, 0, sz.width, sz.height)
        bd = Bmp.LockBits(rct, Imaging.ImageLockMode.ReadOnly, Imaging.PixelFormat.Format24bppRgb)

        ']
        Dim srcptr As IntPtr = bd.Scan0
        Dim srcoff As Integer = 0
        Dim dstptr As IntPtr = mIplImage.imageData
        Dim dstoff As Integer = 0
        For y As Integer = 0 To sz.height - 1
            CopyMemory(dstptr, srcptr, sz.width * 3)
            srcptr = CType(srcptr.ToInt32 + bd.Stride, IntPtr)
            dstptr = CType(dstptr.ToInt32 + mIplImage.widthStep, IntPtr)
        Next

        'rbg}bṽbN
        Bmp.UnlockBits(bd)

    End Sub

    ''' <summary>
    ''' C[Wj܂B
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Release()

        'C[W̔j
        cvReleaseImage(mImagePtr)
        mImagePtr = IntPtr.Zero

        'rbg}bv̔j
        If mBitmap IsNot Nothing Then
            mBitmap.Dispose()
            mBitmap = Nothing
        End If

        'C[Wf[^̃NA
        mIplImage = New IplImage

        'e평
        mIplImageCreated = False

    End Sub

#End Region

    '------------------------------------------------------
#Region "C[Wf[^֘A"

    ''' <summary>
    ''' IplImage\̂ւ̃|C^擾Eݒ肵܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns>݂IplImage\̂ւ̃|C^</returns>
    ''' <remarks>
    ''' VlꍇArbg}bvXV܂B
    ''' </remarks>
    Public Property Ptr() As IntPtr
        Get
            Return mImagePtr
        End Get
        Set(ByVal value As IntPtr)
            mImagePtr = value
            Update()
        End Set
    End Property

    ''' <summary>
    ''' IplImage\̂擾܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns>C[WIplImage\</returns>
    ''' <remarks>
    ''' ̍\̂̓A}l[Ẅ悩̃Rs[ł邽߁A
    ''' \̂̃oɑł͗LɂȂ܂B
    ''' ύX\̂̓eLɂɂUpdateIplImage\bhĂяoĂB
    ''' </remarks>
    Public ReadOnly Property IplImageData() As IplImage
        Get
            ConvertIplImage()
            Return mIplImage
        End Get
    End Property

    ''' <summary>
    ''' C[W̃TCY擾܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns>C[W̃TCY</returns>
    ''' <remarks></remarks>
    Public ReadOnly Property [CvSize]() As CvSize
        Get
            Return New CvSize(Me.IplImageData.width, Me.IplImageData.height)
        End Get
    End Property

    ''' <summary>
    ''' C[W̃TCY擾܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns>C[W̃TCY</returns>
    ''' <remarks></remarks>
    Public ReadOnly Property [Size]() As Size
        Get
            Return New Size(Me.IplImageData.width, Me.IplImageData.height)
        End Get
    End Property

    ''' <summary>
    ''' rbg}bv̊i[擾Eݒ肵܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns>݂̊i[(0:Top-Left,1:Bottom-Left)</returns>
    ''' <remarks>
    ''' ꍇAA}l[ẄIplImage\̂XV܂B
    ''' </remarks>
    Public Property Origin() As Integer
        Get
            Return Me.IplImageData.origin
        End Get
        Set(ByVal value As Integer)
            ConvertIplImage()
            mIplImage.origin = value
            UpdateIplImage()
        End Set
    End Property

    ''' <summary>
    ''' `l擾܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Channel() As Integer
        Get
            Return Me.IplImageData.nChannels
        End Get
    End Property

    ''' <summary>
    ''' C[W(rbg}bvf[^)̃oCg擾܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ImageSize() As Integer
        Get
            Return Me.IplImageData.imageSize
        End Get
    End Property

    ''' <summary>
    ''' C[W(rbg}bvf[^)i[ĂA}l[Ẅ̃AhX擾Eݒ肵܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ImageData() As IntPtr
        Get
            Return Me.IplImageData.imageData
        End Get
        Set(ByVal value As IntPtr)
            ConvertIplImage()
            mIplImage.imageData = value
            UpdateIplImage()
        End Set
    End Property

    ''' <summary>
    ''' }l[ẄIplImage\̂̓eA}l[ẄɃRs[܂B
    ''' </summary>
    ''' <remarks>
    ''' DatavpeB̃oύXꍇAUpdateIplImage\bhĂяoKv܂B
    ''' </remarks>
    Public Sub UpdateIplImage()
        If mIplImageCreated Then
            Marshal.StructureToPtr(mIplImage, mImagePtr, True)
        End If
    End Sub

    ''' <summary>
    ''' A}l[Ẅ悩}l[ẄIplImage\̃f[^Rs[܂B
    ''' </summary>
    ''' <remarks>płB</remarks>
    Private Sub ConvertIplImage()
        If Not mIplImageCreated Then
            mIplImage = CType(Marshal.PtrToStructure(mImagePtr, GetType(IplImage)), IplImage)
            mIplImageCreated = True
        End If
    End Sub

#End Region

    '------------------------------------------------------
#Region "rbg}bvC[W֘A"

    ''' <summary>
    ''' IplImage摜̃rbg}bv擾܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns>ŌɍXVꂽrbg}bv</returns>
    ''' <remarks>
    ''' C[WXVꂽꍇUpdate\bhĂяoKv܂B
    ''' Update\bhĂяoAPtrɃ|C^܂
    ''' ŌɎ擾rbg}bvԂ܂B
    ''' </remarks>
    Public ReadOnly Property [Bitmap]() As Bitmap
        Get
            CreateBitmap()
            Return mBitmap
        End Get
    End Property

    ''' <summary>
    ''' rbg}bv擾ɐVrbg}bv쐬悤ɂ܂B
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Update()
        mIplImageCreated = False
        If mBitmap IsNot Nothing Then
            mBitmap.Dispose()
            mBitmap = Nothing
        End If
    End Sub

    ''' <summary>
    ''' rbg}bv쐬܂B
    ''' </summary>
    ''' <remarks>
    ''' rbg[xIPL_DEPTH_8Uɂ̂ݑΉĂ܂B
    ''' `l13̂ݑΉĂ܂B
    ''' `l1̏ꍇOCXP[摜A3̏ꍇJ[摜ƂȂ܂B
    ''' </remarks>
    Private Sub CreateBitmap()

        'ԃ`FbN
        If mBitmap IsNot Nothing Then Exit Sub
        If mImagePtr = IntPtr.Zero Then Exit Sub

        '``FbN
        If Me.IplImageData.depth <> IPL_DEPTH_8U Then
            Throw New Exception("rbg[x IPL_DEPTH_8U ̂ݑΉĂ܂B")
        End If
        Dim pf As Drawing.Imaging.PixelFormat
        Select Case Me.IplImageData.nChannels
            Case 1
                pf = Imaging.PixelFormat.Format8bppIndexed
            Case 3
                pf = Imaging.PixelFormat.Format24bppRgb
            Case Else
                Throw New Exception("`l 1  3 ̂ݑΉĂ܂B")
        End Select

        'C[Wf[^
        ConvertIplImage()

        'rbg}bv
        If Not mBitmap Is Nothing Then

            'TCY/`Ȃ΍ėp
            If (mBitmap.Size <> Me.Size) OrElse (mBitmap.PixelFormat <> pf) Then
                'ėps
                'VK쐬邽ߌ݂̃rbg}bvj
                mBitmap.Dispose()
                mBitmap = Nothing
            Else
                'ėp\
            End If

        End If
        If mBitmap Is Nothing Then

            '쐬
            mBitmap = New Bitmap(Me.Size.Width, Me.Size.Height, pf)

            'Pv[p̏ꍇAO[XP[̃pbg𐶐
            If pf = Imaging.PixelFormat.Format8bppIndexed Then
                Dim plt As Drawing.Imaging.ColorPalette = mBitmap.Palette
                For x As Integer = 0 To 255
                    plt.Entries(x) = Color.FromArgb(x, x, x)
                Next
                mBitmap.Palette = plt
            End If

        End If

        ']
        Dim rct As New Rectangle(0, 0, Me.Size.Width, Me.Size.Height)
        Dim bd As Imaging.BitmapData = mBitmap.LockBits(rct, Imaging.ImageLockMode.WriteOnly, mBitmap.PixelFormat)
        If bd.Stride * bd.Height = Me.IplImageData.imageSize Then
            ']
            CopyMemory(bd.Scan0, Me.IplImageData.imageData, Me.IplImageData.imageSize)
        End If
        mBitmap.UnlockBits(bd)

        ']
        If Me.Origin = IPL_ORIGIN_BL Then
            'f[^i[{gAbv̏ꍇA㉺ւ
            mBitmap.RotateFlip(RotateFlipType.RotateNoneFlipY)
        End If

        '

    End Sub

#End Region

    '------------------------------------------------------
#Region "\֌W"

    ''' <summary>
    ''' \pEBhE擾Eݒ肵܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Window() As CuWindow
        Get

            'mF
            If mWindow Is Nothing Then
                '쐬
                mWindow = New CuWindow()
            End If

            Return mWindow
        End Get
        Set(ByVal value As CuWindow)
            mWindow = value
        End Set
    End Property

    ''' <summary>
    ''' C[W\܂B
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Show()

        'mF
        If mImagePtr = IntPtr.Zero Then Exit Sub

        '\
        Me.Window.Show(mImagePtr)

    End Sub

#End Region

    '------------------------------------------------------
#Region "C[W"

    ''' <summary>
    ''' A}l[Ẅ悩rbg}bvf[^]܂B
    ''' </summary>
    ''' <remarks>
    ''' ImagevpeBŃrbg}bvf[^𑀍삷OɌĂяoKv܂B
    ''' </remarks>
    Public Sub Load()

        'NA
        ReDim mImage(-1)

        'mF
        If mImagePtr = IntPtr.Zero Then Exit Sub

        '̈쐬
        ReDim mImage(Me.ImageSize - 1)

        ']
        Marshal.Copy(Me.ImageData, mImage, 0, Me.ImageSize)

    End Sub

    ''' <summary>
    ''' rbg}bvf[^A}l[Ẅɓ]܂B
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Store()

        'mF
        If mImagePtr = IntPtr.Zero Then Exit Sub
        If mImage.Length <> Me.ImageSize Then
            Throw New Exception("rbg}bvf[^Ă܂B")
        End If

        ']
        Marshal.Copy(mImage, 0, Me.ImageData, Me.ImageSize)

    End Sub

    ''' <summary>
    ''' A}l[Ẅɓ]ꂽrbg}bvf[^z擾܂B
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' OLoad\bhŃrbg}bvf[^z쐬ĂKv܂B
    ''' rbg}bvf[^XVAStore\bhĂяoƂ
    ''' A}l[ẄɃrbg}bvf[^]A
    ''' C[WXV܂B
    ''' </remarks>
    Public ReadOnly Property Image() As Byte()
        Get
            Return mImage
        End Get
    End Property

    ''' <summary>
    ''' rbg}bvf[^̃CfbNX擾܂B
    ''' </summary>
    ''' <param name="x">W</param>
    ''' <param name="y">W</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetImageIndex(ByVal x As Integer, ByVal y As Integer) As Integer
        Return Me.IplImageData.widthStep * y + Me.IplImageData.nChannels * x
    End Function

#End Region

End Class
